Package: nleqslv
Type: Package
Title: Solve Systems of Nonlinear Equations
Version: 3.3.1
Date: 2017-07-06
Author: Berend Hasselman
Maintainer: Berend Hasselman <bhh@xs4all.nl>
Description: Solve a system of nonlinear equations using a Broyden or a Newton method
             with a choice of global strategies such as line search and trust region.
             There are options for using a numerical or user supplied Jacobian,
             for specifying a banded numerical Jacobian and for allowing
             a singular or ill-conditioned Jacobian.
License: GPL (>= 2)
NeedsCompilation: yes
Packaged: 2017-07-05 09:43:30 UTC; berendhasselman
Repository: CRAN
Date/Publication: 2017-07-06 10:30:03 UTC
Built: R 3.3.2; x86_64-w64-mingw32; 2017-09-04 13:32:27 UTC; windows
Archs: x64

Package: nleqslv
Version: 3.3.5
Title: Solve Systems of Nonlinear Equations
Date: 2023-11-25
Author: Berend Hasselman
Maintainer: Berend Hasselman <bhh@xs4all.nl>
Description: Solve a system of nonlinear equations using a Broyden or a Newton method
             with a choice of global strategies such as line search and trust region.
             There are options for using a numerical or user supplied Jacobian,
             for specifying a banded numerical Jacobian and for allowing
             a singular or ill-conditioned Jacobian.
License: GPL (>= 2)
NeedsCompilation: yes
Packaged: 2023-11-24 19:45:26 UTC; berendhasselman
Repository: CRAN
Date/Publication: 2023-11-26 23:30:14 UTC
Built: R 4.5.3; x86_64-apple-darwin23.6.0; 2026-04-11 22:38:25 UTC; unix

The .R files generate the trace for the iteration report section in the help/manual.

They were run in OS X 10.10.3 with the following bash commands

export R_LIBS=../../../nleqslv.Rcheck
for k in *.R; do R CMD BATCH --no-timing $k ; done

in the directory <path to nleqslv package-source>/inst/iterationreport.

If they are run elsewhere you shouldn't need the export command.
If these are run in a different OS or with another version of R results may be marginally different.
If they are very different then I would like to be informed.

The iteration reports are excerpts from the .Rout files and slightly modified with
intercolumn some whitespace removed.
The actual reports may be extracted from the .Rout file with this bash command

for file in *.Rout ; do  gawk '/  Iter /, /^[$]x/  { if($0 != "$x" ) print }' $file > $(basename $file).txt ; done

Some editing will be needed before including the reports in the documentation.

# R. Baker Kearfott, Some tests of Generalized Bisection,
# ACM Transactions on Methematical Software, Vol. 13, No. 3, 1987, pp 197-220

# A high-degree polynomial system (section 4.3 Problem 12)
# There are 12 real roots (and 126 complex roots to this system!)

library(nleqslv)

hdp <- function(x) {
    f <- numeric(length(x))
    f[1] <- 5 * x[1]^9 - 6 * x[1]^5 * x[2]^2 + x[1] * x[2]^4 + 2 * x[1] * x[3]
    f[2] <- -2 * x[1]^6 * x[2] + 2 * x[1]^2 * x[2]^3 + 2 * x[2] * x[3]
    f[3] <- x[1]^2 + x[2]^2 - 0.265625
    f
}


N <- 40
set.seed(123)
xstart <- matrix(runif(3*N,min=-1,max=1), N, 3)  # N starting values, each of length 3

ans <- searchZeros(xstart,hdp, method="Broyden",global="dbldog")
nrow(ans$x) == 12
all(ans$xfnorm <= 1e-10)

zans <- searchZeros(ans$xstart,hdp, method="Broyden",global="dbldog")
length(zans$idxcvg) == 12

library(nleqslv)

# Dennis Schnabel example 6.5.1 page 149
f <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1]-1) + x[2]^3 - 2
    y
}

# check error handling in control argument
try(nleqslv(f,control=list(1e-3)))
try(nleqslv(f,control=list(f=1e-3)))
try(nleqslv(f,control=list(f=1e-7,b=1e-3)))

# Dennis Schnabel example

library("nleqslv")

dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1]-1) + x[2]^3 - 2
    y
}

jacdsln <- function(x) {
    n <- length(x)
    Df <- matrix(numeric(n*n),n,n)
    Df[1,1] <- 2*x[1]
    Df[1,2] <- 2*x[2]
    Df[2,1] <- exp(x[1]-1)
    Df[2,2] <- 3*x[2]^2

    Df
}

xstart <- c(2,0.5)
fstart <- dslnex(xstart)
xstart
fstart

# a solution is c(1,1)

do.print.xf <- FALSE

print.result <- function(z) {
    if( do.print.xf ) {
        print(z$x)
        print(z$fvec)
    }
    print(z$message)
    print(all(abs(z$fvec)<=1e-8))
}

# Use automatic scaling of x-values. Dosn't always work.

# Broyden numerical Jacobian
for( z in c("qline", "gline") ) {  # quadratic, geometric linesearch
    znlq <- nleqslv(xstart, dslnex, global=z,xscalm="auto",control=list(btol=.01))
    print.result(znlq)
}

# Broyden numerical Jacobian
for( z in c("dbldog","pwldog") ) {  # double dogleg, Powell (single) dogleg
    for( delta in c(-1.0, -2.0) ) { # Cauchy step , Newton step
        znlq <- nleqslv(xstart, dslnex, global=z,xscalm="auto", control=list(btol=.01,delta=delta))
        print.result(znlq)
    }
}

# Broyden analytical jacobian
for( z in c("dbldog","pwldog") ) {  # double dogleg, Powell (single) dogleg
    for( delta in c(-1.0, -2.0) ) { # Cauchy step , Newton step
        znlq <- nleqslv(xstart, dslnex, jacdsln, global=z,xscalm="auto", control=list(btol=.01,delta=delta))
        print.result(znlq)
    }
}

# Newton analytical jacobian
for( z in c("dbldog","pwldog") ) {  # double dogleg, Powell (single) dogleg
    for( delta in c(-1.0, -2.0) ) { # Cauchy step , Newton step
        znlq <- nleqslv(xstart, dslnex, jacdsln, method="Newton", global=z,xscalm="auto", control=list(btol=.01,delta=delta))
        print.result(znlq)
    }
}

# Broyden tridiagonal

library("nleqslv")

brdtri <- function(x) {
    n <- length(x)
    y <- numeric(n)

    y[1] <- (3-2*x[1])*x[1] - 2*x[2] + 1
    y[n] <- (3-2*x[n])*x[n] - x[n-1] + 1

    k <- 2:(n-1)
    y[k] <- (3-2*x[k])*x[k] - x[k-1] - 2 * x[k+1] + 1

    y
}

n <- 100
xstart <- -rep(1,n)
ztol <- 1000*.Machine$double.eps

z1 <- nleqslv(xstart,brdtri, method="Newton")
z2 <- nleqslv(xstart,brdtri, method="Newton", control=list(dsub=1,dsuper=1))

cat("z1 termcd=",z1$termcd, "jcnt,fcnt=",z1$njcnt,z1$nfcnt,"\n")
cat("z2 termcd=",z2$termcd, "jcnt,fcnt=",z2$njcnt,z2$nfcnt,"\n")
z1$message
z2$message
all.equal(z2$x,z1$x)
all.equal(z2$x,z1$x, tolerance=ztol)

z1 <- nleqslv(xstart,brdtri, method="Newton")
z2 <- nleqslv(xstart,brdtri, method="Newton", control=list(dsub=1,dsuper=1))

cat("z1 termcd=",z1$termcd, "jcnt,fcnt=",z1$njcnt,z1$nfcnt,"\n")
cat("z2 termcd=",z2$termcd, "jcnt,fcnt=",z2$njcnt,z2$nfcnt,"\n")
z1$message
z2$message
all.equal(z2$x,z1$x, tolerance=ztol)

z3 <- nleqslv(xstart,brdtri, method="Broyden")
z4 <- nleqslv(xstart,brdtri, method="Broyden", control=list(dsub=1,dsuper=1))

cat("z3 termcd=",z1$termcd, "jcnt,fcnt=",z3$njcnt,z3$nfcnt,"\n")
cat("z4 termcd=",z2$termcd, "jcnt,fcnt=",z4$njcnt,z4$nfcnt,"\n")
z3$message
z4$message
all.equal(z3$x,z1$x)
all.equal(z4$x,z1$x)
all.equal(z4$x,z3$x, tolerance=ztol)

library(nleqslv)

# Dennis & Schnabel,1996,"Numerical methods for unconstrained optimization and nonlinear equations", SIAM
# example 6.5.1 page 149

dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1]-1) + x[2]^3 - 2
    y
}


do.print.xf <- FALSE
do.trace <- 0
print.result <- function(z) {
    if( do.print.xf ) {
        print(z$x)
        print(z$fvec)
    }
    print(z$message)
    print(all(abs(z$fvec)<=1e-8))
}

xcmp.result <- function(z1,z2)  all(abs(z1$x-z2$x) <= 1e-8)

xstart <- c(2,0.5)
hnlq1 <- nleqslv(xstart, dslnex, global="hook", control=list(btol=.01,delta="cauchy", trace=do.trace))
hnlq2 <- nleqslv(xstart, dslnex, global="hook", control=list(btol=.01,delta="newton", trace=do.trace))
print.result(hnlq1)
print.result(hnlq2)
xcmp.result(hnlq1,hnlq2)

dnlq1 <- nleqslv(xstart, dslnex, global="dbldog", control=list(btol=.01,delta="cauchy", trace=do.trace))
dnlq2 <- nleqslv(xstart, dslnex, global="dbldog", control=list(btol=.01,delta="newton", trace=do.trace))
print.result(dnlq1)
print.result(dnlq2)
xcmp.result(dnlq1,dnlq2)
xcmp.result(hnlq1,dnlq1)

xstart <- c(1.1,1.1)
hnlq1 <- nleqslv(xstart, dslnex, global="hook", control=list(btol=.01,delta="cauchy", trace=do.trace))
hnlq2 <- nleqslv(xstart, dslnex, global="hook", control=list(btol=.01,delta="newton", trace=do.trace))
print.result(hnlq1)
print.result(hnlq2)
xcmp.result(hnlq1,hnlq2)

dnlq1 <- nleqslv(xstart, dslnex, global="dbldog", control=list(btol=.01,delta="cauchy", trace=do.trace))
dnlq2 <- nleqslv(xstart, dslnex, global="dbldog", control=list(btol=.01,delta="newton", trace=do.trace))
print.result(dnlq1)
print.result(dnlq2)
xcmp.result(dnlq1,dnlq2)
xcmp.result(hnlq1,dnlq1)

# Chebyquad functions (no solution for n=8)

library("nleqslv")

chebyquad <- function(x) {
	n <- length(x)
	y <- numeric(n)

	for(j in 1:n) {
		t1 <- 1.0
		t2 <- 2.0*x[j] - 1.0
		tmp <- 2.0*t2

    	for(i in 1:n) {
			y[i] <- y[i] + t2
			t3 <- tmp * t2 - t1
			t1 <- t2
			t2 <- t3
		}
	}

	y = y / n

	for(i in 1:n) {
    	if ( i%%2 == 0 ) {
			y[i] = y[i] + 1.0 / (i * i - 1)
		}
	}

	y
}

chebyinit <- function(n) {
    x <- (1:n) / (n + 1)
}

for (n in c(1:7,9)) {  # exclude n=8 since there is no solution
	xstart <- chebyinit(n)
	fstart <- chebyquad(xstart)

	zz <- nleqslv(xstart, chebyquad, global="dbldog",
	              control=list(ftol=1e-8,xtol=1e-8,trace=0,btol=.01,delta=-2))
	print(all(abs(zz$fvec)<=1e-8))
}

for (n in c(1:7,9)) {  # exclude n=8 since there is no solution
	xstart <- chebyinit(n)
	fstart <- chebyquad(xstart)

	zz <- nleqslv(xstart, chebyquad, global="dbldog", method="Newton",
	              control=list(ftol=1e-8,xtol=1e-8,trace=0,btol=.01,delta=-2))
	print(all(abs(zz$fvec)<=1e-8))
}

# Dennis & Schnabel,1996,"Numerical methods for unconstrained optimization and nonlinear equations", SIAM
# example 6.5.1 page 149

library(nleqslv)
packageVersion("nleqslv")
.libPaths()

dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1]-1) + x[2]^3 - 2
    y
}

jacdsln <- function(x) {
    n <- length(x)
    Df <- matrix(numeric(n*n),n,n)
    Df[1,1] <- 2*x[1]
    Df[1,2] <- 2*x[2]
    Df[2,1] <- exp(x[1]-1)
    Df[2,2] <- 3*x[2]^2

    Df
}

xstart <- c(2,0.5)

# \section{Report for the single (Powell) dogleg global method}
nleqslv(xstart,dslnex, global="none", jacobian=TRUE, control=list(trace=1,stepmax=1))

# Broyden banded function

library(nleqslv)

brdtri <- function(x) {
	n <- length(x)
    y <- numeric(n)

    # y[1] <- (3-2*x[1])*x[1] - 2*x[2] + 1
    # y[n] <- (3-2*x[n])*x[n] - x[n-1] + 1
    #
    # k <- 2:(n-1)
    # y[k] <- (3-2*x[k])*x[k] - x[k-1] - 2 * x[k+1] + 1
    #
    y <- (3-2*x)*x - c(0,x[-n]) - 2*c(x[-1],0) + 1
	y
}

brdtrijac <- function(x) {
    n <- length(x)
    J <- diag(3-4*x,n,n)
    J[row(J)==col(J)+1] <- -1
    J[row(J)==col(J)-1] <- -2
    J
}

options(echo=TRUE)

n <- 10
xstart <- -rep(1,n)
fstart <- brdtri(xstart)

z0 <- nleqslv(xstart,brdtri, method="Newton", global="dbldog")
z0$message

z1 <- nleqslv(xstart,brdtri, brdtrijac, method="Newton", global="dbldog",control=list(trace=0))
z1$message
all.equal(z1$x,z0$x)

z2 <- nleqslv(xstart,brdtri, brdtrijac, method="Newton", global="dbldog",control=list(trace=0,chkjac=TRUE))
z2$message
all.equal(z2$x,z0$x)

z3 <- nleqslv(xstart,brdtri, brdtrijac, method="Newton", global="dbldog",control=list(trace=0,dsub=1,dsuper=1))
z3$message
all.equal(z2$x,z0$x)

z4 <- nleqslv(xstart,brdtri, brdtrijac, method="Newton", global="dbldog",control=list(trace=0,dsub=1,dsuper=1,chkjac=TRUE))
z4$message
all.equal(z2$x,z0$x)

library(nleqslv)

f <- function(x) {
    y <-numeric(length(x))
    y[1] <- x[1]^2 + x[2]^3
    y[2] <- x[1] + 2*x[2] + 3
    y
}

# test named x-values
xstart <- c(a=1.0, b=0.5)
xstart

z <- nleqslv(xstart,f, control=list(trace=0))
all(names(z$x) == names(xstart))

# test named x-values
xstart <- c(u=1.0, 0.5)
xstart

z <- nleqslv(xstart,f, control=list(trace=0))
all(names(z$x) == names(xstart))

# Dennis & Schnabel,1996,"Numerical methods for unconstrained optimization and nonlinear equations", SIAM
# example 6.5.1 page 149

library(nleqslv)
packageVersion("nleqslv")
.libPaths()

dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1]-1) + x[2]^3 - 2
    y
}

xstart <- c(2,0.5)

# \section{Report for linesearch methods}
cat("Linesearch qline\n----------------\n")
nleqslv(xstart,dslnex, global="qline", control=list(trace=1))
# These two not in iteration report doc
cat("\nLinesearch gline\n----------------\n")
nleqslv(xstart,dslnex, global="gline", control=list(trace=1))
cat("\nLinesearch cline\n----------------\n")
nleqslv(xstart,dslnex, global="cline", control=list(trace=1))

# Dennis & Schnabel,1996,"Numerical methods for unconstrained optimization and nonlinear equations", SIAM
# example 6.5.1 page 149

library(nleqslv)

dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1]-1) + x[2]^3 - 2
    y
}

jacdsln <- function(x) {
    n <- length(x)
    Df <- matrix(numeric(n*n),n,n)
    Df[1,1] <- 2*x[1]
    Df[1,2] <- 2*x[2]
    Df[2,1] <- exp(x[1]-1)
    Df[2,2] <- 3*x[2]^2

    Df
}

do.print.xf <- FALSE
do.trace <- 0

print.result <- function(z) {
    if( do.print.xf ) {
        print(z$x)
        print(z$fvec)
    }
    print(z$message)
    print(all(abs(z$fvec)<=1e-8))
}

xstart <- c(2,.5)

z <- nleqslv(xstart,dslnex, jacobian=TRUE, control=list(trace=do.trace))
print.result(z)
all.equal(z$jac,jacdsln(z$x), tolerance=0.05)

z <- nleqslv(xstart,dslnex,jacdsln, jacobian=TRUE, control=list(trace=do.trace))
print.result(z)
all.equal(z$jac,jacdsln(z$x), tolerance=0.05)

z <- nleqslv(xstart,dslnex, method="Newton", jacobian=TRUE, control=list(trace=do.trace))
print.result(z)
all.equal(z$jac,jacdsln(z$x), tolerance=10^3*.Machine$double.eps^0.5)

z <- nleqslv(xstart,dslnex, jacdsln, method="Newton", jacobian=TRUE, control=list(trace=do.trace))
print.result(z)
identical(z$jac,jacdsln(z$x))

library("nleqslv")

# Trigonometric function
trig <- function(x) {
	n <- length(x)
	y <- cos(x)
	s <- sum(y)
	y <- n - s + c(1:n) * (1-y) - sin(x)

	y
}

trigjac <- function(x) {
	n <- length(x)
	J <- matrix(numeric(n*n),n,n)

	for (p in 1:n) {
		J[,p]  <- sin(x[p])
		J[p,p] <- (p+1) * sin(x[p]) - cos(x[p])
	}

	J
}

do.print.xf <- FALSE

print.result <- function(z) {
    if( do.print.xf ) {
        print(z$x)
        print(z$fvec)
    }
    print(z$message)
    print(all(abs(z$fvec)<=1e-8))
}

n <- 10
xstart <- rep(1,n)/n
fstart <- trig(xstart)

znlm <- nleqslv(xstart, trig, global="dbldog", control=list(trace=0))
print.result(znlm)

library("nleqslv")

# Dennis & Schnabel,1996,"Numerical methods for unconstrained optimization and nonlinear equations", SIAM
# example 6.5.1 page 149

dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1]-1) + x[2]^3 - 2
    y
}


xstart <- c(2,0.5)
fstart <- dslnex(xstart)
xstart
fstart

do.print.xf <- TRUE

print.result <- function(z) {
    if( do.print.xf ) {
        print(z$x)
        print(z$fvec)
    }
    print(z$message)
    print(all(abs(z$fvec)<=1e-8))
}

sink("dslnexCN-num.txt")
for( z in c("dbldog","pwldog") ) {  # double dogleg, Powell (single) dogleg
    for( delta in c(-1.0, -2.0) ) { # Cauchy step , Newton step
        znlq <- nleqslv(xstart, dslnex, global=z, control=list(btol=.01,delta=delta, trace=1))
        print.result(znlq)
    }
}
sink()

sink("dslnexCN-char.txt")
for( z in c("dbldog","pwldog") ) {  # double dogleg, Powell (single) dogleg
    for( delta in c("cauchy", "newton") ) { # Cauchy step , Newton step
        znlq <- nleqslv(xstart, dslnex, global=z, control=list(btol=.01,delta=delta,trace=1))
        print.result(znlq)
    }
}
sink()

z1 <- readLines(con="dslnexCN-num.txt")
z2 <- readLines(con="dslnexCN-char.txt")

all.equal(z1,z2)

library(nleqslv)

# Brown almost linear function

brown <- function(x) {
  	n <- length(x)
	y <- numeric(n)

  	y[1:(n-1)] <- x[1:(n-1)] + sum(x[1:n]) - (n + 1)
  	y[n] <- prod(x[1:n]) - 1.0

	y
}

brownjac <- function(x) {
    n <- length(x)
    J <- matrix(1,nrow=n,ncol=n)
    diag(J) <- 2
	xprod <- prod(x)
    J[n,] <- xprod/x  # exact
    J
}

print.result <- function(z, do.print.xf=FALSE) {
    if( do.print.xf ) {
        print(z$x)
        print(z$fvec)
    }
    print(z$message)
    print(all(abs(z$fvec)<=1e-8))
}

for( m in c("Newton","Broyden") ) {
    for( n in c(50,100) ) {
        xstart <- rep(1,n)/2
        z <- nleqslv(xstart, brown, brownjac, method="Newton",
                        control=list(trace=0,ftol=1e-10,delta="cauchy",allowSingular=TRUE))
        print.result(z)
    }
}

# Broyden banded function

library("nleqslv")

brdban <- function(x) {
	ml <- 5
	mu <- 1
	n <- length(x)
    y <- numeric(n)

	for( k in 1:n ) {

		k1 <- max(1, k - ml)
		k2 <- min(n, k + mu)

		temp = 0.0
		for(j in k1:k2) {
			if ( j != k ) {
				temp <- temp + x[j] * (1.0 + x[j])
		    }
		}

		y[k] <- x[k] * (2.0 + 5.0 * x[k]**2) + 1.0 - temp

	}
	y
}

n <- 10
xstart <- -rep(1,n)

xsol <- c( -0.42830,  -0.47660,  -0.51965,  -0.55810,  -0.59251,
           -0.62450,  -0.62324,  -0.62139,  -0.62045,  -0.58647  )

fsol <- brdban(xsol)

znlq <- nleqslv(xstart, brdban, global="dbldog", method="Newton",
                control=list(trace=0,ftol=1e-8,xtol=1e-8,btol=1e-2,delta=-1.0))
znlq$termcd                 # should be 2 for x values within tolerance
all(abs(znlq$fvec)<=1e-7)   # may not have achieved ftol

xstart <- -2*rep(1,n)
znlq <- nleqslv(xstart, brdban, global="dbldog", method="Newton",
                control=list(trace=0,ftol=1e-8,xtol=1e-8,btol=1e-2,delta=-1.0))
znlq$termcd
all(abs(znlq$fvec)<=1e-8)

znlq <- nleqslv(xstart, brdban, global="dbldog",
                control=list(trace=0,ftol=1e-8,xtol=1e-8,btol=1e-2,delta=-1.0))
znlq$termcd                 # should be 2 for x values within tolerance
all(abs(znlq$fvec)<=1e-7)   # may not have achieved ftol

xstart <- -2*rep(1,n)
znlq <- nleqslv(xstart, brdban, global="dbldog",
                control=list(trace=0,ftol=1e-8,xtol=1e-8,btol=1e-2,delta=-1.0))
znlq$termcd
all(abs(znlq$fvec)<=1e-8)

# Steady-State solution for reaction rate equations
# Shacham homotopy method (discrete changing of one or more parameters)
# M. Shacham: Numerical Solution of Constrained Non-linear algebriac equations
# International Journal for Numerical Methods in Engineering, 1986, pp.1455--1481.

# solution should always be > 0

library(nleqslv)

RNGkind(kind="Wichmann-Hill")
set.seed(123)

# Problem 2, page 1463/1464

cutlip <- function(x) {
    # paper has wrong order of parameters
    # use the Fortran program to get the correct values

    # parameter set 2
    k1 <-  17.721
    k2 <-  3.483
    k3 <-  505.051
    kr1<-  0.118
    kr2<-  0.033

    r <- numeric(6)

    r[1] = 1 - x[1] - k1*x[1]*x[6] + kr1 * x[4]
    r[2] = 1 - x[2] - k2*x[2]*x[6] + kr2 * x[5]
    r[3] = -x[3] + 2*k3*x[4]*x[5]
    r[4] = k1*x[1]*x[6] - kr1*x[4] - k3*x[4]*x[5]
    r[5] = 1.5*(k2*x[2]*x[6] - kr2*x[5]) - k3*x[4]*x[5]
    r[6] = 1 - x[4] - x[5] - x[6]

    r
}


Nrep <- 50
xstart <- matrix(0,nrow=Nrep, ncol=6)
xstart[,1] <- runif(Nrep,min=0,max=2)
xstart[,2] <- runif(Nrep,min=0,max=1)
xstart[,3] <- runif(Nrep,min=0,max=2)
xstart[,4] <- runif(Nrep,min=0,max=1)
xstart[,5] <- runif(Nrep,min=0,max=1)
xstart[,6] <- runif(Nrep,min=0,max=1)

ans <- searchZeros(xstart,cutlip, method="Broyden",global="dbldog")
nrow(ans$x)==4
all(ans$xfnorm <= 1e-10)

zans <- searchZeros(ans$xstart,cutlip, method="Broyden",global="dbldog")
length(zans$idxcvg)==4
all(ans$xfnorm == zans$xfnorm)

library(nleqslv)

print.result <- function(z, do.print.xf=FALSE) {
    if( do.print.xf ) {
        print(z$x)
        print(z$fvec)
    }
    print(z$message)
    print(all(abs(z$fvec)<=1e-8))
}

# Powell cautionary example
# M.J.D. Powell, "A Hybrid Method for Nonlinear Equations",
# in Numerical methods for Nonlinear Algebraic Equations, ed. P. Rabinowitz, 1970.


f <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]
    y[2] <- 10*x[1]/(x[1]+.1) + 2*x[2]^2

    y
}

jac <- function(x) {
    fjac <- matrix(0,nrow=2,ncol=2)

    fjac[1, 1] <- 1
    fjac[1, 2] <- 0
    fjac[2, 1] <- 1/(x[1]+0.1)^2
    fjac[2, 2] <- 4*x[2]

    fjac
}

xstart <- c(3,1)
z1 <- nleqslv(xstart,f, method="Newton",control=list(trace=0,allowSingular=TRUE))
print.result(z1)
xstart <- c(3,0) # singular start
z2 <- nleqslv(xstart,f, method="Newton",control=list(trace=0,allowSingular=TRUE))
print.result(z2)

# Broyden banded

library("nleqslv")

brdban <- function(x,ml=5,mu=1) {
    n <- length(x)
    y <- numeric(n)

    for( k in 1:n ) {

        k1 <- max(1, k - ml)
        k2 <- min(n, k + mu)

        temp <- 0.0
        for(j in k1:k2) {
            if ( j != k ) {
                temp <- temp + x[j] * (1.0 + x[j])
            }
        }

        y[k] <- x[k] * (2.0 + 5.0 * x[k]**2) + 1.0 - temp

    }
    y
}

n <- 10
xstart <- -rep(1,n)
ztol <- 1000*.Machine$double.eps

z1 <- nleqslv(xstart,brdban, method="Newton")
z2 <- nleqslv(xstart,brdban, method="Newton", control=list(dsub=5,dsuper=1))

cat("z1 termcd=",z1$termcd, "jcnt,fcnt=",z1$njcnt,z1$nfcnt,"\n")
cat("z2 termcd=",z2$termcd, "jcnt,fcnt=",z2$njcnt,z2$nfcnt,"\n")
z1$message
z2$message
all.equal(z2$x,z1$x)
all.equal(z2$x,z1$x, tolerance=ztol)

z1 <- nleqslv(xstart,brdban, ml=2,mu=2, method="Newton")
z2 <- nleqslv(xstart,brdban, ml=2,mu=2, method="Newton", control=list(dsub=2,dsuper=2))

cat("z1 termcd=",z1$termcd, "jcnt,fcnt=",z1$njcnt,z1$nfcnt,"\n")
cat("z2 termcd=",z2$termcd, "jcnt,fcnt=",z2$njcnt,z2$nfcnt,"\n")
z1$message
z2$message
all.equal(z2$x,z1$x, tolerance=ztol)

z3 <- nleqslv(xstart,brdban, ml=2,mu=2, method="Broyden")
z4 <- nleqslv(xstart,brdban, ml=2,mu=2, method="Broyden", control=list(dsub=2,dsuper=2))

cat("z3 termcd=",z1$termcd, "jcnt,fcnt=",z3$njcnt,z3$nfcnt,"\n")
cat("z4 termcd=",z2$termcd, "jcnt,fcnt=",z4$njcnt,z4$nfcnt,"\n")
z3$message
z4$message
all.equal(z3$x,z1$x)
all.equal(z4$x,z1$x)
all.equal(z4$x,z3$x, tolerance=ztol)

# http://stackoverflow.com/questions/29134996/solving-nonlinear-equation-in-r

# wants to know if system has closed form solution
# I want to see how nleqslv behaves

set.seed(29)

library(nleqslv)

print.result <- function(z, do.print.xf=FALSE) {
    if( do.print.xf ) {
        print(z$x)
        print(z$fvec)
    }
    print(z$message)
    print(all(abs(z$fvec)<=1e-8))
}

f <- function(X, a, b, c1, c2, c3) {
    Y <- numeric(3)
    x <- X[1]
    y <- X[2]
    z <- X[3]
    Y[1] <- x + y - x*y - c1
    Y[2] <- x + z - x*z - c2
    Y[3] <- a*y + b*z - c3
    return(Y)
}

Jac <- function(X, a, b, c1, c2, c3) {
    J <- matrix(0,nrow=3,ncol=3)
    x <- X[1]
    y <- X[2]
    z <- X[3]

    J[1,1] <- 1-y
    J[2,1] <- 1-z
    J[3,1] <- 0
    J[1,2] <- 1-x
    J[2,2] <- 0
    J[3,2] <- a
    J[1,3] <- 0
    J[2,3] <- 1-x
    J[3,3] <- b
    J
}

a <- 1
b <- 1
c1 <- 2
c2 <- 3
c3 <- 4

# exact solution
x <- (a*c1+b*c2-c3)/(a+b-c3)
y <- (b*c1-b*c2-c1*c3+c3)/(-a*c1+a-b*c2+b)
z <- (a*(c1-c2)+(c2-1)*c3)/(a*(c1-1)+b*(c2-1))
xsol <- c(x,y,z)

X.start <- c(1,2,3)
z1 <- nleqslv(X.start,f,Jac,a=a,b=b,c1=c1,c2=c2,c3=c3,
                method="Newton",control=list(trace=0,allowSingular=TRUE))

z2 <- nleqslv(X.start,f,Jac,a=a,b=b,c1=c1,c2=c2,c3=c3,
        method="Broyden",control=list(trace=0,allowSingular=TRUE))

all.equal(z1$x,xsol)
all.equal(z2$x,xsol)
print.result(z1)
print.result(z2)

# Dennis & Schnabel,1996,"Numerical methods for unconstrained optimization and nonlinear equations", SIAM
# example 6.5.1 page 149

library(nleqslv)
packageVersion("nleqslv")
.libPaths()

dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1]-1) + x[2]^3 - 2
    y
}

jacdsln <- function(x) {
    n <- length(x)
    Df <- matrix(numeric(n*n),n,n)
    Df[1,1] <- 2*x[1]
    Df[1,2] <- 2*x[2]
    Df[2,1] <- exp(x[1]-1)
    Df[2,2] <- 3*x[2]^2

    Df
}

xstart <- c(2,0.5)

# \section{Report for the double dogleg global method}
nleqslv(xstart,dslnex, global="dbldog", jacobian=TRUE, control=list(trace=1,delta="cauchy"))

library(nleqslv)

# function to replace small number with OK or if not with NZ
# this is to avoid differences in the Fnorm column between machines/cpu/os/compilers

# the test is for checking that testnslv (still) works as expected

fixsmall <- function(x) {
    z <- ifelse(x < .Machine$double.eps^(2/3), "OK","NZ")
    z <- ifelse(is.na(z), "NA", z)
    z
}

dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1]-1) + x[2]^3 - 2
    y
}
xstart <- c(0.5,0.5)
fstart <- dslnex(xstart)
z <- testnslv(xstart,dslnex)
zfn <- z$out[,"Fnorm"]
z$out[,"Fnorm"] <- fixsmall(zfn)
z

# this will encounter an error
xstart <- c(2.0,0.5)
fstart <- dslnex(xstart)
z <- testnslv(xstart,dslnex)
zfn <- z$out[,"Fnorm"]
z$out[,"Fnorm"] <- fixsmall(zfn)
z
